-- VERSION MANAGEMENT
TK_version = "Beta 1.6"
TK_builddate = "04/15/2014"
TK_buildtime = "1:08 PM PDT"

-- SAVED VARIABLES
defaults = {
	["isEnabled"] = true,
	["position"] = { ["x"] = 690,
					 ["y"] = 280 }
}

function TKSkillTrackerPosition(self)	
	sv.position.x = self:GetLeft()
	sv.position.y = self:GetTop()
end

-- KEYBINDINGS
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_SKILL_TRACKER", "Toggle Skill Tracker")

function TKSkillTrackerUI_ToggleWindow()
	setEnabled(not sv.isEnabled)
end

-- TOGGLE SKILL TRACKER
function setEnabled(window_state)
	if not window_state
	then 
		TKSkillTrackerUI:SetHidden(true)
		sv.isEnabled = false
	else 
		TKSkillTrackerUI:SetHidden(false)
		sv.isEnabled = true
	end
end

-- ADDON INITIALIZATION
function TKSkillTrackerInit( eventCode, addOnName )
	if addOnName ~= "TKSkillTracker"
	then
		return
	end	
	sv = ZO_SavedVars:New("TKSkillTrackerSV", 2, nil, defaults, nil)
	TKSkillTrackerUI:SetHidden(not sv.isEnabled)
	TKSkillTrackerUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, sv.position.x,sv.position.y)
	TKSkillTrackerUI:SetWidth(300)
	TKSkillTrackerUI:SetHeight(669)
	TKSkillTrackerUpdate()
end

-- AUTOHIDE FUNCTION
function TKAutoHide()
	TK_menu1 = ZO_GameMenu_InGame:IsHidden()
	TK_menu2 = ZO_KeybindStripControlBackground:IsHidden()
	TK_menu3 = ZO_InteractWindow:IsHidden()
	TK_menu4 = ZO_Character:IsHidden()
	if not TK_menu1 or not TK_menu2 or not TK_menu3 or not TK_menu4
	then
		TKSkillTrackerUI:SetMouseEnabled(false)
		TKSkillTrackerUIBG:SetHidden(true)
		TKSkillTrackerUITitle:SetHidden(true)
		TKSkillTrackerUIClassTitle:SetHidden(true)
		TKSkillTrackerUIClassSkill1Name:SetHidden(true)
		TKSkillTrackerUIClassSkill2Name:SetHidden(true)
		TKSkillTrackerUIClassSkill3Name:SetHidden(true)
		TKSkillTrackerUIClassRank:SetHidden(true)
		TKSkillTrackerUIClassSkill1Rank:SetHidden(true)
		TKSkillTrackerUIClassSkill2Rank:SetHidden(true)
		TKSkillTrackerUIClassSkill3Rank:SetHidden(true)
		TKSkillTrackerUIClassXP:SetHidden(true)
		TKSkillTrackerUIClassSkill1XP:SetHidden(true)
		TKSkillTrackerUIClassSkill2XP:SetHidden(true)
		TKSkillTrackerUIClassSkill3XP:SetHidden(true)
		TKSkillTrackerUIWeaponTitle:SetHidden(true)
		TKSkillTrackerUIWeaponSkill1Name:SetHidden(true)
		TKSkillTrackerUIWeaponSkill2Name:SetHidden(true)
		TKSkillTrackerUIWeaponSkill3Name:SetHidden(true)
		TKSkillTrackerUIWeaponSkill4Name:SetHidden(true)
		TKSkillTrackerUIWeaponSkill5Name:SetHidden(true)
		TKSkillTrackerUIWeaponSkill6Name:SetHidden(true)
		TKSkillTrackerUIWeaponRank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill1Rank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill2Rank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill3Rank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill4Rank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill5Rank:SetHidden(true)
		TKSkillTrackerUIWeaponSkill6Rank:SetHidden(true)
		TKSkillTrackerUIWeaponXP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill1XP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill2XP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill3XP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill4XP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill5XP:SetHidden(true)
		TKSkillTrackerUIWeaponSkill6XP:SetHidden(true)
		TKSkillTrackerUIArmorTitle:SetHidden(true)
		TKSkillTrackerUIArmorSkill1Name:SetHidden(true)
		TKSkillTrackerUIArmorSkill2Name:SetHidden(true)
		TKSkillTrackerUIArmorSkill3Name:SetHidden(true)
		TKSkillTrackerUIArmorRank:SetHidden(true)
		TKSkillTrackerUIArmorSkill1Rank:SetHidden(true)
		TKSkillTrackerUIArmorSkill2Rank:SetHidden(true)
		TKSkillTrackerUIArmorSkill3Rank:SetHidden(true)
		TKSkillTrackerUIArmorXP:SetHidden(true)
		TKSkillTrackerUIArmorSkill1XP:SetHidden(true)
		TKSkillTrackerUIArmorSkill2XP:SetHidden(true)
		TKSkillTrackerUIArmorSkill3XP:SetHidden(true)
		TKSkillTrackerUIWorldTitle:SetHidden(true)
		TKSkillTrackerUIWorldSkill1Name:SetHidden(true)
		TKSkillTrackerUIWorldSkill2Name:SetHidden(true)
		TKSkillTrackerUIWorldSkill3Name:SetHidden(true)
		TKSkillTrackerUIWorldRank:SetHidden(true)
		TKSkillTrackerUIWorldSkill1Rank:SetHidden(true)
		TKSkillTrackerUIWorldSkill2Rank:SetHidden(true)
		TKSkillTrackerUIWorldSkill3Rank:SetHidden(true)
		TKSkillTrackerUIWorldXP:SetHidden(true)
		TKSkillTrackerUIWorldSkill1XP:SetHidden(true)
		TKSkillTrackerUIWorldSkill2XP:SetHidden(true)
		TKSkillTrackerUIWorldSkill3XP:SetHidden(true)
		TKSkillTrackerUIGuildTitle:SetHidden(true)
		TKSkillTrackerUIGuildSkill1Name:SetHidden(true)
		TKSkillTrackerUIGuildSkill2Name:SetHidden(true)
		TKSkillTrackerUIGuildSkill3Name:SetHidden(true)
		TKSkillTrackerUIGuildRank:SetHidden(true)
		TKSkillTrackerUIGuildSkill1Rank:SetHidden(true)
		TKSkillTrackerUIGuildSkill2Rank:SetHidden(true)
		TKSkillTrackerUIGuildSkill3Rank:SetHidden(true)
		TKSkillTrackerUIGuildXP:SetHidden(true)
		TKSkillTrackerUIGuildSkill1XP:SetHidden(true)
		TKSkillTrackerUIGuildSkill2XP:SetHidden(true)
		TKSkillTrackerUIGuildSkill3XP:SetHidden(true)
		TKSkillTrackerUIRacialTitle:SetHidden(true)
		TKSkillTrackerUIRacialSkill1Name:SetHidden(true)
		TKSkillTrackerUIRacialRank:SetHidden(true)
		TKSkillTrackerUIRacialSkill1Rank:SetHidden(true)
		TKSkillTrackerUIRacialXP:SetHidden(true)
		TKSkillTrackerUIRacialSkill1XP:SetHidden(true)
		TKSkillTrackerUITradeTitle:SetHidden(true)
		TKSkillTrackerUITradeSkill1Name:SetHidden(true)
		TKSkillTrackerUITradeSkill2Name:SetHidden(true)
		TKSkillTrackerUITradeSkill3Name:SetHidden(true)
		TKSkillTrackerUITradeSkill4Name:SetHidden(true)
		TKSkillTrackerUITradeSkill5Name:SetHidden(true)
		TKSkillTrackerUITradeSkill6Name:SetHidden(true)
		TKSkillTrackerUITradeRank:SetHidden(true)
		TKSkillTrackerUITradeSkill1Rank:SetHidden(true)
		TKSkillTrackerUITradeSkill2Rank:SetHidden(true)
		TKSkillTrackerUITradeSkill3Rank:SetHidden(true)
		TKSkillTrackerUITradeSkill4Rank:SetHidden(true)
		TKSkillTrackerUITradeSkill5Rank:SetHidden(true)
		TKSkillTrackerUITradeSkill6Rank:SetHidden(true)
		TKSkillTrackerUITradeXP:SetHidden(true)
		TKSkillTrackerUITradeSkill1XP:SetHidden(true)
		TKSkillTrackerUITradeSkill2XP:SetHidden(true)
		TKSkillTrackerUITradeSkill3XP:SetHidden(true)
		TKSkillTrackerUITradeSkill4XP:SetHidden(true)
		TKSkillTrackerUITradeSkill5XP:SetHidden(true)
		TKSkillTrackerUITradeSkill6XP:SetHidden(true)
	else
		TKSkillTrackerUI:SetMouseEnabled(true)
		TKSkillTrackerUIBG:SetHidden(false)
		TKSkillTrackerUITitle:SetHidden(false)
		TKSkillTrackerUIClassTitle:SetHidden(false)
		TKSkillTrackerUIClassSkill1Name:SetHidden(false)
		TKSkillTrackerUIClassSkill2Name:SetHidden(false)
		TKSkillTrackerUIClassSkill3Name:SetHidden(false)
		TKSkillTrackerUIClassRank:SetHidden(false)
		TKSkillTrackerUIClassSkill1Rank:SetHidden(false)
		TKSkillTrackerUIClassSkill2Rank:SetHidden(false)
		TKSkillTrackerUIClassSkill3Rank:SetHidden(false)
		TKSkillTrackerUIClassXP:SetHidden(false)
		TKSkillTrackerUIClassSkill1XP:SetHidden(false)
		TKSkillTrackerUIClassSkill2XP:SetHidden(false)
		TKSkillTrackerUIClassSkill3XP:SetHidden(false)
		TKSkillTrackerUIWeaponTitle:SetHidden(false)
		TKSkillTrackerUIWeaponSkill1Name:SetHidden(false)
		TKSkillTrackerUIWeaponSkill2Name:SetHidden(false)
		TKSkillTrackerUIWeaponSkill3Name:SetHidden(false)
		TKSkillTrackerUIWeaponSkill4Name:SetHidden(false)
		TKSkillTrackerUIWeaponSkill5Name:SetHidden(false)
		TKSkillTrackerUIWeaponSkill6Name:SetHidden(false)
		TKSkillTrackerUIWeaponRank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill1Rank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill2Rank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill3Rank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill4Rank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill5Rank:SetHidden(false)
		TKSkillTrackerUIWeaponSkill6Rank:SetHidden(false)
		TKSkillTrackerUIWeaponXP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill1XP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill2XP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill3XP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill4XP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill5XP:SetHidden(false)
		TKSkillTrackerUIWeaponSkill6XP:SetHidden(false)
		TKSkillTrackerUIArmorTitle:SetHidden(false)
		TKSkillTrackerUIArmorSkill1Name:SetHidden(false)
		TKSkillTrackerUIArmorSkill2Name:SetHidden(false)
		TKSkillTrackerUIArmorSkill3Name:SetHidden(false)
		TKSkillTrackerUIArmorRank:SetHidden(false)
		TKSkillTrackerUIArmorSkill1Rank:SetHidden(false)
		TKSkillTrackerUIArmorSkill2Rank:SetHidden(false)
		TKSkillTrackerUIArmorSkill3Rank:SetHidden(false)
		TKSkillTrackerUIArmorXP:SetHidden(false)
		TKSkillTrackerUIArmorSkill1XP:SetHidden(false)
		TKSkillTrackerUIArmorSkill2XP:SetHidden(false)
		TKSkillTrackerUIArmorSkill3XP:SetHidden(false)
		TKSkillTrackerUIWorldTitle:SetHidden(false)
		TKSkillTrackerUIWorldSkill1Name:SetHidden(false)
		TKSkillTrackerUIWorldSkill2Name:SetHidden(false)
		TKSkillTrackerUIWorldSkill3Name:SetHidden(false)
		TKSkillTrackerUIWorldRank:SetHidden(false)
		TKSkillTrackerUIWorldSkill1Rank:SetHidden(false)
		TKSkillTrackerUIWorldSkill2Rank:SetHidden(false)
		TKSkillTrackerUIWorldSkill3Rank:SetHidden(false)
		TKSkillTrackerUIWorldXP:SetHidden(false)
		TKSkillTrackerUIWorldSkill1XP:SetHidden(false)
		TKSkillTrackerUIWorldSkill2XP:SetHidden(false)
		TKSkillTrackerUIWorldSkill3XP:SetHidden(false)
		TKSkillTrackerUIGuildTitle:SetHidden(false)
		TKSkillTrackerUIGuildSkill1Name:SetHidden(false)
		TKSkillTrackerUIGuildSkill2Name:SetHidden(false)
		TKSkillTrackerUIGuildSkill3Name:SetHidden(false)
		TKSkillTrackerUIGuildRank:SetHidden(false)
		TKSkillTrackerUIGuildSkill1Rank:SetHidden(false)
		TKSkillTrackerUIGuildSkill2Rank:SetHidden(false)
		TKSkillTrackerUIGuildSkill3Rank:SetHidden(false)
		TKSkillTrackerUIGuildXP:SetHidden(false)
		TKSkillTrackerUIGuildSkill1XP:SetHidden(false)
		TKSkillTrackerUIGuildSkill2XP:SetHidden(false)
		TKSkillTrackerUIGuildSkill3XP:SetHidden(false)
		TKSkillTrackerUIRacialTitle:SetHidden(false)
		TKSkillTrackerUIRacialSkill1Name:SetHidden(false)
		TKSkillTrackerUIRacialRank:SetHidden(false)
		TKSkillTrackerUIRacialSkill1Rank:SetHidden(false)
		TKSkillTrackerUIRacialXP:SetHidden(false)
		TKSkillTrackerUIRacialSkill1XP:SetHidden(false)
		TKSkillTrackerUITradeTitle:SetHidden(false)
		TKSkillTrackerUITradeSkill1Name:SetHidden(false)
		TKSkillTrackerUITradeSkill2Name:SetHidden(false)
		TKSkillTrackerUITradeSkill3Name:SetHidden(false)
		TKSkillTrackerUITradeSkill4Name:SetHidden(false)
		TKSkillTrackerUITradeSkill5Name:SetHidden(false)
		TKSkillTrackerUITradeSkill6Name:SetHidden(false)
		TKSkillTrackerUITradeRank:SetHidden(false)
		TKSkillTrackerUITradeSkill1Rank:SetHidden(false)
		TKSkillTrackerUITradeSkill2Rank:SetHidden(false)
		TKSkillTrackerUITradeSkill3Rank:SetHidden(false)
		TKSkillTrackerUITradeSkill4Rank:SetHidden(false)
		TKSkillTrackerUITradeSkill5Rank:SetHidden(false)
		TKSkillTrackerUITradeSkill6Rank:SetHidden(false)
		TKSkillTrackerUITradeXP:SetHidden(false)
		TKSkillTrackerUITradeSkill1XP:SetHidden(false)
		TKSkillTrackerUITradeSkill2XP:SetHidden(false)
		TKSkillTrackerUITradeSkill3XP:SetHidden(false)
		TKSkillTrackerUITradeSkill4XP:SetHidden(false)
		TKSkillTrackerUITradeSkill5XP:SetHidden(false)
		TKSkillTrackerUITradeSkill6XP:SetHidden(false)
	end
end

-- UPDATE FUNCTION
function TKSkillTrackerUpdate()
	sv = ZO_SavedVars:New("TKSkillTrackerSV", 2, nil, defaults, nil)
	TKSkillTrackerUI:SetHidden(not sv.isEnabled)
	TKAutoHide()
	
	-- WINDOW TITLE
	TKSkillTrackerUITitle:SetText(string.format("Skill Tracker - " .. TK_version))
	
	-- CLASS SKILLS
	TKSkillTrackerUIClassTitle:SetText(string.format("Class Skills"))
	TKSkillTrackerUIClassRank:SetText(string.format("Rank"))
	TKSkillTrackerUIClassXP:SetText(string.format("XP"))	
	classSkill1Name,classSkill1Rank = GetSkillLineInfo(SKILL_TYPE_CLASS, 1)
	classSkill1LastXP,classSkill1NextXP,classSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_CLASS, 1)
	classSkill1XPPct = (classSkill1CurXP - classSkill1LastXP) / (classSkill1NextXP - classSkill1LastXP) * 100
	TKSkillTrackerUIClassSkill1Name:SetText(string.format(classSkill1Name))
	TKSkillTrackerUIClassSkill1Rank:SetText(string.format(classSkill1Rank))
	TKSkillTrackerUIClassSkill1XP:SetText(string.format(classSkill1CurXP - classSkill1LastXP .. " / " ..classSkill1NextXP - classSkill1LastXP .. " (" .. math.floor(classSkill1XPPct) .."%%)"))
	classSkill2Name,classSkill2Rank = GetSkillLineInfo(SKILL_TYPE_CLASS, 2)
	classSkill2LastXP,classSkill2NextXP,classSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_CLASS, 2)
	classSkill2XPPct = (classSkill2CurXP - classSkill2LastXP) / (classSkill2NextXP - classSkill2LastXP) * 100
	TKSkillTrackerUIClassSkill2Name:SetText(string.format(classSkill2Name))
	TKSkillTrackerUIClassSkill2Rank:SetText(string.format(classSkill2Rank))
	TKSkillTrackerUIClassSkill2XP:SetText(string.format(classSkill2CurXP - classSkill2LastXP .. " / " ..classSkill2NextXP - classSkill2LastXP .. " (" .. math.floor(classSkill2XPPct) .."%%)"))
	classSkill3Name,classSkill3Rank = GetSkillLineInfo(SKILL_TYPE_CLASS, 3)
	classSkill3LastXP,classSkill3NextXP,classSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_CLASS, 3)
	classSkill3XPPct = (classSkill3CurXP - classSkill3LastXP) / (classSkill3NextXP - classSkill3LastXP) * 100
	TKSkillTrackerUIClassSkill3Name:SetText(string.format(classSkill3Name))
	TKSkillTrackerUIClassSkill3Rank:SetText(string.format(classSkill3Rank))
	TKSkillTrackerUIClassSkill3XP:SetText(string.format(classSkill3CurXP - classSkill3LastXP .. " / " ..classSkill3NextXP - classSkill3LastXP .. " (" .. math.floor(classSkill3XPPct) .."%%)"))

	-- WEAPON SKILLS
	TKSkillTrackerUIWeaponTitle:SetText(string.format("Weapon Skills"))
	TKSkillTrackerUIWeaponRank:SetText(string.format("Rank"))
	TKSkillTrackerUIWeaponXP:SetText(string.format("XP"))
	weaponSkill1Name,weaponSkill1Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 1)
	weaponSkill1LastXP,weaponSkill1NextXP,weaponSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 1)
	weaponSkill1XPPct = (weaponSkill1CurXP - weaponSkill1LastXP) / (weaponSkill1NextXP - weaponSkill1LastXP) * 100
	TKSkillTrackerUIWeaponSkill1Name:SetText(string.format(weaponSkill1Name))
	TKSkillTrackerUIWeaponSkill1Rank:SetText(string.format(weaponSkill1Rank))
	TKSkillTrackerUIWeaponSkill1XP:SetText(string.format(weaponSkill1CurXP - weaponSkill1LastXP .. " / " ..weaponSkill1NextXP - weaponSkill1LastXP .. " (" .. math.floor(weaponSkill1XPPct) .."%%)"))
	weaponSkill2Name,weaponSkill2Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 2)
	weaponSkill2LastXP,weaponSkill2NextXP,weaponSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 2)
	weaponSkill2XPPct = (weaponSkill2CurXP - weaponSkill2LastXP) / (weaponSkill2NextXP - weaponSkill2LastXP) * 100
	TKSkillTrackerUIWeaponSkill2Name:SetText(string.format(weaponSkill2Name))
	TKSkillTrackerUIWeaponSkill2Rank:SetText(string.format(weaponSkill2Rank))
	TKSkillTrackerUIWeaponSkill2XP:SetText(string.format(weaponSkill2CurXP - weaponSkill2LastXP .. " / " ..weaponSkill2NextXP - weaponSkill2LastXP .. " (" .. math.floor(weaponSkill2XPPct) .."%%)"))
	weaponSkill3Name,weaponSkill3Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 3)
	weaponSkill3LastXP,weaponSkill3NextXP,weaponSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 3)
	weaponSkill3XPPct = (weaponSkill3CurXP - weaponSkill3LastXP) / (weaponSkill3NextXP - weaponSkill3LastXP) * 100
	TKSkillTrackerUIWeaponSkill3Name:SetText(string.format(weaponSkill3Name))
	TKSkillTrackerUIWeaponSkill3Rank:SetText(string.format(weaponSkill3Rank))
	TKSkillTrackerUIWeaponSkill3XP:SetText(string.format(weaponSkill3CurXP - weaponSkill3LastXP .. " / " ..weaponSkill3NextXP - weaponSkill3LastXP .. " (" .. math.floor(weaponSkill3XPPct) .."%%)"))
	weaponSkill4Name,weaponSkill4Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 4)
	weaponSkill4LastXP,weaponSkill4NextXP,weaponSkill4CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 4)
	weaponSkill4XPPct = (weaponSkill4CurXP - weaponSkill4LastXP) / (weaponSkill4NextXP - weaponSkill4LastXP) * 100
	TKSkillTrackerUIWeaponSkill4Name:SetText(string.format(weaponSkill4Name))
	TKSkillTrackerUIWeaponSkill4Rank:SetText(string.format(weaponSkill4Rank))
	TKSkillTrackerUIWeaponSkill4XP:SetText(string.format(weaponSkill4CurXP - weaponSkill4LastXP .. " / " ..weaponSkill4NextXP - weaponSkill4LastXP .. " (" .. math.floor(weaponSkill4XPPct) .."%%)"))
	weaponSkill5Name,weaponSkill5Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 5)
	weaponSkill5LastXP,weaponSkill5NextXP,weaponSkill5CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 5)
	weaponSkill5XPPct = (weaponSkill5CurXP - weaponSkill5LastXP) / (weaponSkill5NextXP - weaponSkill5LastXP) * 100
	TKSkillTrackerUIWeaponSkill5Name:SetText(string.format(weaponSkill5Name))
	TKSkillTrackerUIWeaponSkill5Rank:SetText(string.format(weaponSkill5Rank))
	TKSkillTrackerUIWeaponSkill5XP:SetText(string.format(weaponSkill5CurXP - weaponSkill5LastXP .. " / " ..weaponSkill5NextXP - weaponSkill5LastXP .. " (" .. math.floor(weaponSkill5XPPct) .."%%)"))
	weaponSkill6Name,weaponSkill6Rank = GetSkillLineInfo(SKILL_TYPE_WEAPON, 6)
	weaponSkill6LastXP,weaponSkill6NextXP,weaponSkill6CurXP = GetSkillLineXPInfo(SKILL_TYPE_WEAPON, 6)
	weaponSkill6XPPct = (weaponSkill6CurXP - weaponSkill6LastXP) / (weaponSkill6NextXP - weaponSkill6LastXP) * 100
	TKSkillTrackerUIWeaponSkill6Name:SetText(string.format(weaponSkill6Name))
	TKSkillTrackerUIWeaponSkill6Rank:SetText(string.format(weaponSkill6Rank))
	TKSkillTrackerUIWeaponSkill6XP:SetText(string.format(weaponSkill6CurXP - weaponSkill6LastXP .. " / " ..weaponSkill6NextXP - weaponSkill6LastXP .. " (" .. math.floor(weaponSkill6XPPct) .."%%)"))

	-- ARMOR SKILLS
	TKSkillTrackerUIArmorTitle:SetText(string.format("Armor Skills"))
	TKSkillTrackerUIArmorRank:SetText(string.format("Rank"))
	TKSkillTrackerUIArmorXP:SetText(string.format("XP"))	
	armorSkill1Name,armorSkill1Rank = GetSkillLineInfo(SKILL_TYPE_ARMOR, 1)
	armorSkill1LastXP,armorSkill1NextXP,armorSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_ARMOR, 1)
	armorSkill1XPPct = (armorSkill1CurXP - armorSkill1LastXP) / (armorSkill1NextXP - armorSkill1LastXP) * 100
	TKSkillTrackerUIArmorSkill1Name:SetText(string.format(armorSkill1Name))
	TKSkillTrackerUIArmorSkill1Rank:SetText(string.format(armorSkill1Rank))
	TKSkillTrackerUIArmorSkill1XP:SetText(string.format(armorSkill1CurXP - armorSkill1LastXP .. " / " ..armorSkill1NextXP - armorSkill1LastXP .. " (" .. math.floor(armorSkill1XPPct) .."%%)"))
	armorSkill2Name,armorSkill2Rank = GetSkillLineInfo(SKILL_TYPE_ARMOR, 2)
	armorSkill2LastXP,armorSkill2NextXP,armorSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_ARMOR, 2)
	armorSkill2XPPct = (armorSkill2CurXP - armorSkill2LastXP) / (armorSkill2NextXP - armorSkill2LastXP) * 100
	TKSkillTrackerUIArmorSkill2Name:SetText(string.format(armorSkill2Name))
	TKSkillTrackerUIArmorSkill2Rank:SetText(string.format(armorSkill2Rank))
	TKSkillTrackerUIArmorSkill2XP:SetText(string.format(armorSkill2CurXP - armorSkill2LastXP .. " / " ..armorSkill2NextXP - armorSkill2LastXP .. " (" .. math.floor(armorSkill2XPPct) .."%%)"))
	armorSkill3Name,armorSkill3Rank = GetSkillLineInfo(SKILL_TYPE_ARMOR, 3)
	armorSkill3LastXP,armorSkill3NextXP,armorSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_ARMOR, 3)
	armorSkill3XPPct = (armorSkill3CurXP - armorSkill3LastXP) / (armorSkill3NextXP - armorSkill3LastXP) * 100
	TKSkillTrackerUIArmorSkill3Name:SetText(string.format(armorSkill3Name))
	TKSkillTrackerUIArmorSkill3Rank:SetText(string.format(armorSkill3Rank))
	TKSkillTrackerUIArmorSkill3XP:SetText(string.format(armorSkill3CurXP - armorSkill3LastXP .. " / " ..armorSkill3NextXP - armorSkill3LastXP .. " (" .. math.floor(armorSkill3XPPct) .."%%)"))
	
	-- WORLD SKILLS
	TKSkillTrackerUIWorldTitle:SetText(string.format("World Skills"))
	TKSkillTrackerUIWorldRank:SetText(string.format("Rank"))
	TKSkillTrackerUIWorldXP:SetText(string.format("XP"))	
	worldSkill1Name,worldSkill1Rank = GetSkillLineInfo(SKILL_TYPE_WORLD, 1)
	worldSkill1LastXP,worldSkill1NextXP,worldSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_WORLD, 1)
	worldSkill1XPPct = (worldSkill1CurXP - worldSkill1LastXP) / (worldSkill1NextXP - worldSkill1LastXP) * 100
	TKSkillTrackerUIWorldSkill1Name:SetText(string.format(worldSkill1Name))
	TKSkillTrackerUIWorldSkill1Rank:SetText(string.format(worldSkill1Rank))
	TKSkillTrackerUIWorldSkill1XP:SetText(string.format(worldSkill1CurXP - worldSkill1LastXP .. " / " ..worldSkill1NextXP - worldSkill1LastXP .. " (" .. math.floor(worldSkill1XPPct) .."%%)"))
	worldSkill2Name,worldSkill2Rank = GetSkillLineInfo(SKILL_TYPE_WORLD, 2)
	worldSkill2LastXP,worldSkill2NextXP,worldSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_WORLD, 2)
	if (worldSkill2Name == "")
	then
		TKSkillTrackerUIWorldSkill2Name:SetText(string.format("Undiscovered"))
		TKSkillTrackerUIWorldSkill2Rank:SetText(string.format("--"))
		TKSkillTrackerUIWorldSkill2XP:SetText(string.format("-- / --"))
	else
	worldSkill2XPPct = (worldSkill2CurXP - worldSkill2LastXP) / (worldSkill2NextXP - worldSkill2LastXP) * 100
	TKSkillTrackerUIWorldSkill2Name:SetText(string.format(worldSkill2Name))
	TKSkillTrackerUIWorldSkill2Rank:SetText(string.format(worldSkill2Rank))
	TKSkillTrackerUIWorldSkill2XP:SetText(string.format(worldSkill2CurXP - worldSkill2LastXP .. " / " ..worldSkill2NextXP - worldSkill2LastXP .. " (" .. math.floor(worldSkill2XPPct) .."%%)"))
	end
	
	worldSkill3Name,worldSkill3Rank = GetSkillLineInfo(SKILL_TYPE_WORLD, 3)
	worldSkill3LastXP,worldSkill3NextXP,worldSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_WORLD, 3)
	if (worldSkill3Name == "")
	then
		TKSkillTrackerUIWorldSkill3Name:SetText(string.format("Undiscovered"))
		TKSkillTrackerUIWorldSkill3Rank:SetText(string.format("--"))
		TKSkillTrackerUIWorldSkill3XP:SetText(string.format("-- / --"))
	else
	worldSkill3XPPct = (worldSkill3CurXP - worldSkill3LastXP) / (worldSkill3NextXP - worldSkill3LastXP) * 100
	TKSkillTrackerUIWorldSkill3Name:SetText(string.format(worldSkill3Name))
	TKSkillTrackerUIWorldSkill3Rank:SetText(string.format(worldSkill3Rank))
	TKSkillTrackerUIWorldSkill3XP:SetText(string.format(worldSkill3CurXP - worldSkill3LastXP .. " / " ..worldSkill3NextXP - worldSkill3LastXP .. " (" .. math.floor(worldSkill3XPPct) .."%%)"))
	end
	
	-- GUILD SKILLS
	TKSkillTrackerUIGuildTitle:SetText(string.format("Guild Skills"))
	TKSkillTrackerUIGuildRank:SetText(string.format("Rank"))
	TKSkillTrackerUIGuildXP:SetText(string.format("XP"))	
	worldSkill1Name,worldSkill1Rank = GetSkillLineInfo(SKILL_TYPE_GUILD, 1)
	worldSkill1LastXP,worldSkill1NextXP,worldSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_GUILD, 1)
	if (worldSkill1Name == "")
	then
		TKSkillTrackerUIGuildSkill1Name:SetText(string.format("Undiscovered"))
		TKSkillTrackerUIGuildSkill1Rank:SetText(string.format("--"))
		TKSkillTrackerUIGuildSkill1XP:SetText(string.format("-- / --"))
	else
	worldSkill1XPPct = (worldSkill1CurXP - worldSkill1LastXP) / (worldSkill1NextXP - worldSkill1LastXP) * 100
	TKSkillTrackerUIGuildSkill1Name:SetText(string.format(worldSkill1Name))
	TKSkillTrackerUIGuildSkill1Rank:SetText(string.format(worldSkill1Rank))
	TKSkillTrackerUIGuildSkill1XP:SetText(string.format(worldSkill1CurXP - worldSkill1LastXP .. " / " ..worldSkill1NextXP - worldSkill1LastXP .. " (" .. math.floor(worldSkill1XPPct) .."%%)"))
	end
	worldSkill2Name,worldSkill2Rank = GetSkillLineInfo(SKILL_TYPE_GUILD, 2)
	worldSkill2LastXP,worldSkill2NextXP,worldSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_GUILD, 2)
	if (worldSkill2Name == "")
	then
		TKSkillTrackerUIGuildSkill2Name:SetText(string.format("Undiscovered"))
		TKSkillTrackerUIGuildSkill2Rank:SetText(string.format("--"))
		TKSkillTrackerUIGuildSkill2XP:SetText(string.format("-- / --"))
	else
	worldSkill2XPPct = (worldSkill2CurXP - worldSkill2LastXP) / (worldSkill2NextXP - worldSkill2LastXP) * 100
	TKSkillTrackerUIGuildSkill2Name:SetText(string.format(worldSkill2Name))
	TKSkillTrackerUIGuildSkill2Rank:SetText(string.format(worldSkill2Rank))
	TKSkillTrackerUIGuildSkill2XP:SetText(string.format(worldSkill2CurXP - worldSkill2LastXP .. " / " ..worldSkill2NextXP - worldSkill2LastXP .. " (" .. math.floor(worldSkill2XPPct) .."%%)"))
	end
	
	worldSkill3Name,worldSkill3Rank = GetSkillLineInfo(SKILL_TYPE_GUILD, 3)
	worldSkill3LastXP,worldSkill3NextXP,worldSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_GUILD, 3)
	if (worldSkill3Name == "")
	then
		TKSkillTrackerUIGuildSkill3Name:SetText(string.format("Undiscovered"))
		TKSkillTrackerUIGuildSkill3Rank:SetText(string.format("--"))
		TKSkillTrackerUIGuildSkill3XP:SetText(string.format("-- / --"))
	else
	worldSkill3XPPct = (worldSkill3CurXP - worldSkill3LastXP) / (worldSkill3NextXP - worldSkill3LastXP) * 100
	TKSkillTrackerUIGuildSkill3Name:SetText(string.format(worldSkill3Name))
	TKSkillTrackerUIGuildSkill3Rank:SetText(string.format(worldSkill3Rank))
	TKSkillTrackerUIGuildSkill3XP:SetText(string.format(worldSkill3CurXP - worldSkill3LastXP .. " / " ..worldSkill3NextXP - worldSkill3LastXP .. " (" .. math.floor(worldSkill3XPPct) .."%%)"))
	end
	
	-- RACIAL SKILLS
	TKSkillTrackerUIRacialTitle:SetText(string.format("Racial Skills"))
	TKSkillTrackerUIRacialRank:SetText(string.format("Rank"))
	TKSkillTrackerUIRacialXP:SetText(string.format("XP"))	
	racialSkill1Name,racialSkill1Rank = GetSkillLineInfo(SKILL_TYPE_RACIAL, 1)
	racialSkill1LastXP,racialSkill1NextXP,racialSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_RACIAL, 1)
	racialSkill1XPPct = (racialSkill1CurXP - racialSkill1LastXP) / (racialSkill1NextXP - racialSkill1LastXP) * 100
	TKSkillTrackerUIRacialSkill1Name:SetText(string.format(racialSkill1Name))
	TKSkillTrackerUIRacialSkill1Rank:SetText(string.format(racialSkill1Rank))
	TKSkillTrackerUIRacialSkill1XP:SetText(string.format(racialSkill1CurXP - racialSkill1LastXP .. " / " ..racialSkill1NextXP - racialSkill1LastXP .. " (" .. math.floor(racialSkill1XPPct) .."%%)"))

	-- TRADE SKILLS
	TKSkillTrackerUITradeTitle:SetText(string.format("Trade Skills"))
	TKSkillTrackerUITradeRank:SetText(string.format("Rank"))
	TKSkillTrackerUITradeXP:SetText(string.format("XP"))
	tradeSkill1Name,tradeSkill1Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 1)
	tradeSkill1LastXP,tradeSkill1NextXP,tradeSkill1CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 1)
	tradeSkill1XPPct = (tradeSkill1CurXP - tradeSkill1LastXP) / (tradeSkill1NextXP - tradeSkill1LastXP) * 100
	TKSkillTrackerUITradeSkill1Name:SetText(string.format(tradeSkill1Name))
	TKSkillTrackerUITradeSkill1Rank:SetText(string.format(tradeSkill1Rank))
	TKSkillTrackerUITradeSkill1XP:SetText(string.format(tradeSkill1CurXP - tradeSkill1LastXP .. " / " ..tradeSkill1NextXP - tradeSkill1LastXP .. " (" .. math.floor(tradeSkill1XPPct) .."%%)"))
	tradeSkill2Name,tradeSkill2Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 2)
	tradeSkill2LastXP,tradeSkill2NextXP,tradeSkill2CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 2)
	tradeSkill2XPPct = (tradeSkill2CurXP - tradeSkill2LastXP) / (tradeSkill2NextXP - tradeSkill2LastXP) * 100
	TKSkillTrackerUITradeSkill2Name:SetText(string.format(tradeSkill2Name))
	TKSkillTrackerUITradeSkill2Rank:SetText(string.format(tradeSkill2Rank))
	TKSkillTrackerUITradeSkill2XP:SetText(string.format(tradeSkill2CurXP - tradeSkill2LastXP .. " / " ..tradeSkill2NextXP - tradeSkill2LastXP .. " (" .. math.floor(tradeSkill2XPPct) .."%%)"))
	tradeSkill3Name,tradeSkill3Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 3)
	tradeSkill3LastXP,tradeSkill3NextXP,tradeSkill3CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 3)
	tradeSkill3XPPct = (tradeSkill3CurXP - tradeSkill3LastXP) / (tradeSkill3NextXP - tradeSkill3LastXP) * 100
	TKSkillTrackerUITradeSkill3Name:SetText(string.format(tradeSkill3Name))
	TKSkillTrackerUITradeSkill3Rank:SetText(string.format(tradeSkill3Rank))
	TKSkillTrackerUITradeSkill3XP:SetText(string.format(tradeSkill3CurXP - tradeSkill3LastXP .. " / " ..tradeSkill3NextXP - tradeSkill3LastXP .. " (" .. math.floor(tradeSkill3XPPct) .."%%)"))
	tradeSkill4Name,tradeSkill4Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 4)
	tradeSkill4LastXP,tradeSkill4NextXP,tradeSkill4CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 4)
	tradeSkill4XPPct = (tradeSkill4CurXP - tradeSkill4LastXP) / (tradeSkill4NextXP - tradeSkill4LastXP) * 100
	TKSkillTrackerUITradeSkill4Name:SetText(string.format(tradeSkill4Name))
	TKSkillTrackerUITradeSkill4Rank:SetText(string.format(tradeSkill4Rank))
	TKSkillTrackerUITradeSkill4XP:SetText(string.format(tradeSkill4CurXP - tradeSkill4LastXP .. " / " ..tradeSkill4NextXP - tradeSkill4LastXP .. " (" .. math.floor(tradeSkill4XPPct) .."%%)"))
	tradeSkill5Name,tradeSkill5Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 5)
	tradeSkill5LastXP,tradeSkill5NextXP,tradeSkill5CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 5)
	tradeSkill5XPPct = (tradeSkill5CurXP - tradeSkill5LastXP) / (tradeSkill5NextXP - tradeSkill5LastXP) * 100
	TKSkillTrackerUITradeSkill5Name:SetText(string.format(tradeSkill5Name))
	TKSkillTrackerUITradeSkill5Rank:SetText(string.format(tradeSkill5Rank))
	TKSkillTrackerUITradeSkill5XP:SetText(string.format(tradeSkill5CurXP - tradeSkill5LastXP .. " / " ..tradeSkill5NextXP - tradeSkill5LastXP .. " (" .. math.floor(tradeSkill5XPPct) .."%%)"))
	tradeSkill6Name,tradeSkill6Rank = GetSkillLineInfo(SKILL_TYPE_TRADESKILL, 6)
	tradeSkill6LastXP,tradeSkill6NextXP,tradeSkill6CurXP = GetSkillLineXPInfo(SKILL_TYPE_TRADESKILL, 6)
	tradeSkill6XPPct = (tradeSkill6CurXP - tradeSkill6LastXP) / (tradeSkill6NextXP - tradeSkill6LastXP) * 100
	TKSkillTrackerUITradeSkill6Name:SetText(string.format(tradeSkill6Name))
	TKSkillTrackerUITradeSkill6Rank:SetText(string.format(tradeSkill6Rank))
	TKSkillTrackerUITradeSkill6XP:SetText(string.format(tradeSkill6CurXP - tradeSkill6LastXP .. " / " ..tradeSkill6NextXP - tradeSkill6LastXP .. " (" .. math.floor(tradeSkill6XPPct) .."%%)"))
end

-- EVENT MANAGER
EVENT_MANAGER:RegisterForEvent( "TKSkillTracker", EVENT_ADD_ON_LOADED, TKSkillTrackerInit )